﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim InternetConnected As Boolean, ph As PhoneEvents
	Public logs As StringBuilder
	Private logcat As LogCat
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	logs.Initialize
	#if RELEASE
		logcat.LogCatStart(Array As String("-v","raw","*:F","B4A:v"), "logcat")
	#end if
End Sub

Sub Service_Start (StartingIntent As Intent)
	ph.Initialize("ph")
	If others.SQL.IsInitialized = False Then
		others.SQL.Initialize(others.Folder, others.dbName, True)	'DB open to check the version
	End If
	Dim v As Int = DBUtils.GetDBVersion(others.SQL)
	Dim NewVer As Int = 2	'set each build when the db structure is changed
	If v < NewVer Then
		others.SQL.Close
		File.Delete(others.Folder, others.dbName)
		others.SQL.Initialize(others.Folder, others.dbName, True)
		v = DBUtils.GetDBVersion(others.SQL)	'set = 1
		DBUtils.SetDBVersion(others.SQL, NewVer)	'set new version
		ToastMessageShow(others.sqlStructureUpdated, False)
	End If
	'-------------------------------------------------------------------
	If others.SQL.IsInitialized = False Then
		others.SQL.Initialize(others.Folder, others.dbName, True)
	End If
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	'wait for 500ms to allow the logs to be updated.
	Dim jo As JavaObject
	Dim l As Long = 500
	jo.InitializeStatic("java.lang.Thread").RunMethod("sleep", Array(l))
	logcat.LogCatStop
	logs.Append(StackTrace)
	ToastMessageShow(others.SendBugReport, True)
	File.WriteString(others.Folder, others.BugReportFileName, logs)
	Dim email1 As Email
	email1.To.Add(others.PublicEmail)
	email1.Subject = Application.LabelName & ": app crash v." & Application.VersionName
	
	Dim hw1 As Phone
	email1.Body = "Mf=" & hw1.Manufacturer & "; Model=" & hw1.Model & "; Product=" & hw1.Product & "; SdkVersion=" & hw1.SdkVersion & CRLF & CRLF & logs
	StartActivity(email1.GetIntent)
	ToastMessageShow(others.SendBugReport, True)
	Return True
End Sub

Sub Service_Destroy
End Sub

Private Sub logcat_LogCatData (Buffer() As Byte, Length As Int)
	logs.Append(BytesToString(Buffer, 0, Length, "utf8"))
	If logs.Length > 20000 Then
		logs.Remove(0, logs.Length - 19000)
	End If
End Sub

Sub ph_ConnectivityChanged (NetworkType As String, State As String, Intent As Intent)
	If State = "CONNECTED" Then
		Log("ph_ConnectivityChanged: CONNECTED" & "," & NetworkType)
		InternetConnected = True
	Else	'NO INTERNET
		Log("ph_ConnectivityChanged: DISCONNECTED")
		InternetConnected = False
	End If
End Sub
