﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'constants
	Public Const BugReportFileName As String = "bugreport.txt"
	Public Const LogFileName As String = "logs.txt"
	Public Const PublicEmail As String = "developer@email.com"
	Public Const dbName As String = "main.sqlite"
	'reading strings
	Public Const SendBugReport As String = "Send this bug-report to the app developers now"
	Public Const SetupYourEmail As String = "Setup your Email-client"
	Public Const CheckYourInternet As String = "Check your Internet-connection..."
	Public Const sqlStructureUpdated As String = "Database structure has been updated, the existing data was deleted."
	'objects for subs
	Dim SQL As SQL
	Dim su As StringUtils
	Dim Notif1 As Notification
	Dim rp As RuntimePermissions
	Dim Logmap As Map
End Sub

Sub Internet_Connected As Boolean
	If Starter.InternetConnected = False Then
		ToastMessageShow(CheckYourInternet, False)
		'Notif(CheckYourInternet, False, False, Main)
		Return False
	End If
	Return True
End Sub

Sub Folder As String
	Dim res As String
	Try
		If File.ExternalWritable Then
			res = rp.GetSafeDirDefaultExternal("")
		Else
			res = File.DirInternal
		End If
	Catch
		res = File.DirInternal
	End Try
	Return res
End Sub

Sub bugreport (Text As String, AttPath As String, AttFileName As String, subj As String)
	Dim Message As Email
	Dim hw1 As Phone
	If subj = "" Then subj = "app error log"
	Dim Subject As String = Application.LabelName & "_v." & Application.VersionName & ": " & subj
	Dim Body As String = "Mf=" & hw1.Manufacturer & "; Model=" & hw1.Model & "; Product=" & hw1.Product & "; SdkVersion=" & hw1.SdkVersion & CRLF & Text
	Dim m As Map
	m.Initialize
	If AttPath.Trim & AttFileName.Trim <> "" Then
		If File.Exists(AttPath, AttFileName) Then
			m = CreateMap(AttFileName: AttPath)
		End If
	End If

	SuperSendEmail(Array As String(PublicEmail), Body, Subject, m)

	ToastMessageShow(SendBugReport, True)
	Try
		StartActivity(Message.GetIntent)
	Catch
		ToastMessageShow(SetupYourEmail, True)
	End Try
End Sub

'SendAtt = map CreateMap("filename1": "path1", "filename2": "path2")
Sub SuperSendEmail (SendTo As List, SendBody As String, SendSubject As String, SendAtt As Map)
	Dim FinalEmailIntent As Intent
	If SendTo.IsInitialized = False Then
		ToastMessageShow("No email 'to'", True)
		Return
	End If
        
	Dim MyEmail As Email
	MyEmail.To = SendTo
	MyEmail.Body = SendBody
	MyEmail.Subject = SendSubject
	If SendAtt.IsInitialized Then
		For i = 0 To SendAtt.Size - 1
			MyEmail.Attachments.Add(CreateFileProviderUri(SendAtt.GetValueAt(i), SendAtt.GetKeyAt(i)))
		Next
	End If
	FinalEmailIntent = MyEmail.GetIntent
	FinalEmailIntent.SetType("message/rfc822")
	FinalEmailIntent.WrapAsIntentChooser("Email:")
	StartActivity (FinalEmailIntent)
End Sub

Sub CreateFileProviderUri (Dir As String, FileName As String) As Object
	Dim FileProvider As JavaObject
	Dim context As JavaObject
	context.InitializeContext
	FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim f As JavaObject
	f.InitializeNewInstance("java.io.File", Array(Dir, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
End Sub

Sub BitmapToBitmapDrawable (bitmap As Bitmap) As BitmapDrawable
	Dim bd As BitmapDrawable
	bd.Initialize(bitmap)
	Return bd
End Sub

Sub FontAwesomeToBitmap (Text As String, FontSize As Float) As B4XBitmap
	Dim xui As XUI
	Dim p As Panel = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 32dip, 32dip)
	Dim cvs1 As B4XCanvas
	cvs1.Initialize(p)
	Dim fnt As B4XFont = xui.CreateFont(Typeface.FONTAWESOME, FontSize)
	Dim r As B4XRect = cvs1.MeasureText(Text, fnt)
	Dim BaseLine As Int = cvs1.TargetRect.CenterY - r.Height / 2 - r.Top
	cvs1.DrawText(Text, cvs1.TargetRect.CenterX, BaseLine, fnt, xui.Color_White, "CENTER")
	Dim b As B4XBitmap = cvs1.CreateBitmap
	cvs1.Release
	Return b
End Sub

Sub Get_DeviceID As String
	Dim phh As Phone
	Dim res As String = phh.GetSettings("android_id")
	Return res
End Sub

Sub Notif(Content As String, Insistent As Boolean, Sound As Boolean, TargetActivity As Object)
	If Notif1.IsInitialized = False Then
		Notif1.Initialize
	End If

	Dim n As Notification
	n.Initialize
	n.Sound = Sound
	n.Vibrate = Sound
	n.Insistent = Insistent
	If Content <> "" Then
		n.Icon = "icon"
	Else
		n.Icon = ""
	End If
	n.AutoCancel = True
	n.Light = Sound
	n.SetInfo(Application.LabelName, Content, TargetActivity)
	Notif1 = n
	Notif1.Notify(10)
End Sub

Sub FillImageToView(bmp As B4XBitmap, ImageView As B4XView)
	Dim bmpRatio As Float = bmp.Width / bmp.Height
	Dim viewRatio As Float = ImageView.Width / ImageView.Height
	If viewRatio > bmpRatio Then
		Dim NewHeight As Int = bmp.Width / viewRatio
		bmp = bmp.Crop(0, bmp.Height / 2 - NewHeight / 2, bmp.Width, NewHeight)
	Else if viewRatio < bmpRatio Then
		Dim NewWidth As Int = bmp.Height * viewRatio
		bmp = bmp.Crop(bmp.Width / 2 - NewWidth / 2, 0, NewWidth, bmp.Height)
	End If
	ImageView.SetBitmap(bmp.Resize(ImageView.Width, ImageView.Height, True))
End Sub

Sub HasFeature(feature As String) As Boolean
	Dim r As Reflector
	r.Target = r.GetContext
	r.Target = r.RunMethod("getPackageManager")
	Return r.RunMethod2("hasSystemFeature", feature, "java.lang.String")
End Sub

Sub SavePicture (dir As String, fn As String, bmp As B4XBitmap)
	If File.Exists(dir, fn) Then
		File.Delete(dir, fn)
	End If
	Dim outs As OutputStream
	outs = File.OpenOutput(dir, fn, False)
	bmp.WriteToStream(outs, 80, "JPEG")
	outs.Close
End Sub

'remove new keys (fields that non-existent in SQL table) before updating the table
Sub JSON_FilterJsonMap (SQL1 As SQL, Table As String, SourceMap As Map) As Map
	Dim Res As ResultSet = SQL1.ExecQuery($"PRAGMA table_info(${Table})"$)
	Dim Out As Map
	Out.Initialize
	Do While Res.NextRow
		For i = 0 To SourceMap.Size - 1
			Dim key As String = SourceMap.GetKeyAt(i)
			Dim name As String = Res.GetString("name")	'db table field name
			If name = key Then
				Out.Put(SourceMap.GetKeyAt(i), SourceMap.GetValueAt(i))
				Exit
			End If
		Next
		If (DateTime.GetSecond(DateTime.Now)/100) Mod 2 = 0 Then DoEvents
	Loop
	Res.Close
	Return Out
End Sub

'RowsListOfMaps - parsed from JSON: say Items=[{PositionType=1, Name=Name1, Count=1}, {PositionType=2, Name=Name2, Count=0.3}]
Sub JSON_CreateTableAuto(SQL1 As SQL, TableName As String, RowsListOfMaps As List)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("(")
	Dim row As Map = RowsListOfMaps.Get(0)
	For i = 0 To row.Size - 1
		Dim field, ftype, fvalue As String
		field = row.GetKeyAt(i)
		fvalue = row.GetValueAt(i)
		If IsNumber(fvalue) = False Then
			ftype = DBUtils.DB_TEXT
		Else
			If fvalue.Contains(".") Then
				ftype = DBUtils.DB_REAL
			Else
				ftype = DBUtils.DB_INTEGER
			End If
		End If
		If i > 0 Then sb.Append(", ")
		sb.Append("[").Append(field).Append("]").Append(" ").Append(ftype)
	Next
	sb.Append(", rowid INTEGER PRIMARY KEY")
	sb.Append(")")
	Dim query As String = "CREATE TABLE IF NOT EXISTS [" & TableName & "] " & sb.ToString
	SQL1.ExecNonQuery(query)
End Sub

Sub JSON_GetObjFromPath(obj As Object, path As String) As Object
	Dim keys() = Regex.Split("/", path) As String : path = ""
	If keys.Length == 0 Then Return obj
	'--------------------------------------------------------
	Dim key As String
	For i = 0 To (keys.Length - 1)
		key = keys(i) : If key <> "" Then Exit
	Next
	If key.Length == 0 Then Return obj
	'--------------------------------------------------------
	For j = i + 1 To (keys.Length - 1)
		path = path & keys(j) & "/"
	Next
	If obj Is Map Then
		Dim map = obj As Map
		obj = JSON_GetObjFromPath(map.GetDefault(key, Null), path)
	Else If obj Is List Then
		Dim lst = obj As List
		Try
			obj = JSON_GetObjFromPath(lst.Get(key), path)
		Catch
			obj = Null
		End Try
	End If
	Return obj
End Sub

Sub maxTextHeight(v As Label) As Float
	Dim fltH As Float = su.MeasureMultilineTextHeight(v, v.Text)
	Return fltH + 3dip
End Sub

Sub maxTextSize(v As View, str As String) As Float
	' Get padding values
	Try
		Dim jo As JavaObject = v
		Dim intPaddingLR As Int= jo.Runmethod("getPaddingLeft",Null) + jo.Runmethod("getPaddingRight",Null)
		Dim intPaddingTB As Int = jo.Runmethod("getPaddingTop",Null) + jo.Runmethod("getPaddingBottom",Null)
		' Set canvas and initialise text size to try
		Dim c As Canvas
		c.Initialize(v)
		Dim fltSize As Float = 70
		Dim fltW As Float = c.MeasureStringWidth(str, Typeface.DEFAULT_BOLD, fltSize)
		Dim fltH As Float = c.MeasureStringHeight(str, Typeface.DEFAULT_BOLD, fltSize)
		' Check if text size will fit, continue reducing until it fits.
		Do While (fltW > (v.Width - intPaddingLR)) Or (fltH > (v.Height - intPaddingTB))
			fltSize = fltSize - 2
			fltW = c.MeasureStringWidth(str, Typeface.DEFAULT_BOLD, fltSize)
			fltH = c.MeasureStringHeight(str, Typeface.DEFAULT_BOLD, fltSize)
			'Log(fltW & " (" & (v.Width - intPaddingLR) & ") " & fltH & " (" & (v.Height - intPaddingTB) & ")")
		Loop
		'Log("Size " & fltSize)
		Return fltSize
	Catch
		Return 10
	End Try
End Sub

'checks if app is installed from Play Market
Sub isFromMarket As Boolean
	Dim Obj1 As Reflector, res As String
	Obj1.Target = Obj1.GetContext
	Obj1.Target = Obj1.RunMethod("getPackageManager")
	res = Obj1.RunMethod2("getInstallerPackageName", Application.PackageName, "java.lang.String")

	If res.ToLowerCase.Contains("vending") Then
		Dim FromMarket As Boolean = True
	Else
		Dim FromMarket As Boolean = False
	End If
	Return FromMarket
End Sub

'compare the app signature with your own SHA-1 like "99:9A:F9:66:CE:AA:BE:E3:D3:2E:AA:AE:CF:C8:AA:18:C4:73:DA:42" from "Private Sign key" B4A settings dialog
Sub GetSignatureHash As String
	Dim jo As JavaObject
	jo.InitializeContext
	Dim signatures() As Object = jo.RunMethodJO("getPackageManager", Null).RunMethodJO("getPackageInfo", _
     Array (Application.PackageName, 0x00000040)).GetField("signatures")
	Dim sig As JavaObject = signatures(0)
	Dim md As MessageDigest
	Dim hash() As Byte = md.GetMessageDigest(sig.RunMethod("toByteArray", Null), "SHA-1")
	Dim bc As ByteConverter
	Dim raw As String = bc.HexFromBytes(hash)
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To raw.Length - 2 Step 2
		sb.Append(raw.CharAt(i)).Append(raw.CharAt(i + 1)).Append(":")
	Next
	sb.Remove(sb.Length - 1, sb.Length)
	Return sb.ToString
End Sub

'algorithm is often used "MD5"
Sub Get_Hash(Text As String, algorithm As String) As String
	Dim bc As ByteConverter
	Dim md As MessageDigest

	Dim data() As Byte
	Dim encrypted() As Byte

	data = bc.StringToBytes(Text, "UTF-8")
	encrypted = md.GetMessageDigest(data, algorithm)
	Dim res As String = bc.HexFromBytes(encrypted)
	Return (res)
End Sub

Sub AddToLog (Text As String)
	If Logmap.IsInitialized = False Then
		Logmap.Initialize
		If File.Exists(Folder, LogFileName) Then
			Logmap = File.ReadMap(Folder, LogFileName)
		End If
	End If

	If Text.Trim = "" Then Return

	If Logmap.Size > 0 Then
		If Logmap.GetValueAt(Logmap.Size - 1) = Text Then Return
	End If

	Dim b As String, d, E As Long, f As Float
	DateTime.DateFormat = "dd.MM.yyyy"
	DateTime.TimeFormat = "HH:mm:ss"
	If Logmap.Size > 5000 Then	'records limit
		Logmap.Remove(Logmap.GetKeyAt(0))	'delete the oldest
	End If

	d = DateTime.Now
	E = d - DateTime.TimeParse(DateTime.Time(d))
	f = E/DateTime.TicksPerSecond
	b = NumberFormat(f, 0, 3)

	Logmap.Put(DateTime.DAte(d) & " " & DateTime.Time(d) & b, Text)
End Sub

Sub GetPathFromContentResult(UriString As String) As String
	If UriString.StartsWith("/") Then Return UriString 'If the user used a file manager to choose the image
	Dim Cursor1 As Cursor
	Dim Uri1 As Uri
	Dim Proj() As String = Array As String("_data")
	Dim cre As ContentResolver
	cre.Initialize("")
	If UriString.StartsWith("content://com.android.providers.media.documents") Then
		Dim i As Int = UriString.IndexOf("%3A")
		Dim id As String = UriString.SubString(i + 3)
		Uri1.Parse("content://media/external/images/media")
		Cursor1 = cre.Query(Uri1, Proj, "_id = ?", Array As String(id), "")
	Else
		Uri1.Parse(UriString)
		Cursor1 = cre.Query(Uri1, Proj, "", Null, "")
	End If
	Cursor1.Position = 0
	Dim res As String
	res = Cursor1.GetString("_data")
	Cursor1.Close
	Return res
End Sub

Sub CopyFolder(Source As String, targetFolder As String)
	If File.Exists(targetFolder, "") = False Then File.MakeDir(targetFolder, "")
	For Each f As String In File.ListFiles(Source)
		If File.IsDirectory(Source, f) Then
			CopyFolder(File.Combine(Source, f), File.Combine(targetFolder, f))
			Continue
		End If
		File.Copy(Source, f, targetFolder, f)
		If (DateTime.GetSecond(DateTime.Now)/100) Mod 2 = 0 Then DoEvents
	Next
End Sub

Sub GetFileName(fullpath As String) As String
	Return fullpath.SubString(fullpath.LastIndexOf("/") + 1)
End Sub

' Depends on: GetFilename
Sub GetPath(Path As String) As String
	Dim Path1 As String
	If Path = "/" Then
		Return "/"
	End If
	Dim L As Int = Path.LastIndexOf("/")
	If L = Path.Length - 1 Then
		'Strip the last slash
		Path1 = Path.SubString2(0,L)
	Else
		Path1 = Path
	End If
	L = Path.LastIndexOf("/")
	If L = 0 Then
		L = 1
	End If
	Return Path1.SubString2(0,L)
End Sub

Sub SetAutoSizeBasedOnText(v As View)
	Dim jo As JavaObject
	jo.InitializeStatic("android.support.v4.widget.TextViewCompat")
	jo.RunMethod("setAutoSizeTextTypeWithDefaults", Array(v, 1))
End Sub

Sub CheckForGooglePlayServices As Boolean
	Dim GoogleApiAvailablity As JavaObject
	GoogleApiAvailablity = GoogleApiAvailablity.InitializeStatic("com.google.android.gms.common.GoogleApiAvailability").RunMethod("getInstance", Null)
	Dim context As JavaObject
	context.InitializeContext
	If GoogleApiAvailablity.RunMethod("isGooglePlayServicesAvailable", Array(context)) <> 0 Then
		GoogleApiAvailablity.RunMethod("makeGooglePlayServicesAvailable", Array(context))
		Return False
	End If
	Return True
End Sub

Sub Get_Language As String
	Dim jo As JavaObject
	Return jo.InitializeStatic("java.util.Locale").RunMethod("getDefault", Null)
End Sub

Sub Show_HomeScreen
	Dim i As Intent
	i.Initialize(i.ACTION_MAIN, "")
	i.AddCategory("android.intent.category.HOME")
	i.Flags = 0x10000000
	StartActivity(i)
End Sub

'depends on GetThursdayOfWeekInTicks
Sub GetWeekNumber(ticks As Long) As Int
	Dim currentThursday, firstThursday As Long
	Dim savedDateFormat As String
	currentThursday = GetThursdayOfWeekInTicks(ticks)
	savedDateFormat = DateTime.DateFormat
	DateTime.DateFormat = "MM/dd/yyyy"
	firstThursday = GetThursdayOfWeekInTicks(DateTime.DateParse("01/04/" & (DateTime.GetYear(currentThursday))))
	DateTime.DateFormat = savedDateFormat
	Return Floor((currentThursday - firstThursday) / DateTime.TicksPerDay / 7 + 1)
End Sub

Sub GetThursdayOfWeekInTicks(ticks As Long) As Long
	Dim diff As Int
	Select DateTime.GetDayOfWeek(ticks)
		' Sunday
		Case 1
			diff = -3
			' Monday
		Case 2
			diff = 3
			' Tuesdy
		Case 3
			diff = 2
			' Wednesday
		Case 4
			diff = 1
			' Thursday
		Case 5
			diff = 0
			' Friday
		Case 6
			diff = -1
			' Saturday
		Case 7
			diff = -2
	End Select
	Return DateTime.Add(ticks, 0, 0, diff)
End Sub

Sub setLabelSingleLine(viewArg As View, singleLineArg As Boolean)
	Dim jo As JavaObject = viewArg
	jo.RunMethod("setSingleLine", Array As Object(singleLineArg))
End Sub

Sub Disable_Horizontal_ScrollBar (v As View)
	Dim r As Reflector
	r.Target = v
	r.RunMethod2("setHorizontalScrollBarEnabled", False, "java.lang.boolean")
	r.RunMethod2("setOverScrollMode", 2, "java.lang.int" )
End Sub

Sub Disable_V_ScrollBar (v As View)
	Dim r As Reflector
	r.Target = v
	r.RunMethod2("setVerticalScrollBarEnabled", False, "java.lang.boolean")
	r.RunMethod2("setOverScrollMode", 2, "java.lang.int" )
End Sub

Sub Enable_V_ScrollBar (v As View)
	Dim r As Reflector
	r.Target = v
	r.RunMethod2("setVerticalScrollBarEnabled", True, "java.lang.boolean")
	r.RunMethod2("setOverScrollMode", 0, "java.lang.int" )
End Sub

Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
	If Original.IsInitialized = False Then
		Return Null
	End If
	Try
		Dim jo As JavaObject
		jo.InitializeStatic("android.graphics.Bitmap")
		Return jo.RunMethod("createScaledBitmap", Array (Original, Width, Height, Filter))
	Catch
		Return Original
	End Try
End Sub

'return "", if no data
Sub GetStringFromSQL (req As String) As String
	Dim a As String
	Try
		a = SQL.ExecQuerySingleResult(req)
	Catch
		Return ""
	End Try

	If a = Null Then
		Return ""
	Else If a.ToLowerCase = "null" Then
		Return ""
	Else If a = "" Then
		Return ""
	Else
		Return a
	End If
End Sub

Sub WebViewAssetFile (FileName As String) As String
	Dim jo As JavaObject
	jo.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
	If jo.GetField("virtualAssetsFolder") = Null Then
		Return "file:///android_asset/" & FileName.ToLowerCase
	Else
		Return "file://" & File.Combine(jo.GetField("virtualAssetsFolder"), _
       jo.RunMethod("getUnpackedVirtualAssetFile", Array As Object(FileName)))
	End If
End Sub

'meters distance
Sub DistanceCalc (p1 As Location, p2 As Location) As Long
	'This sub calculates the distance and course between two Lat/Lon coordinates.
	'The formulas are based on this site: http://williams.best.vwh.net/avform.htm (Ed Williams)
	Dim lat1, lat2, lon1, lon2, Dist, D As Double
	lat1=p1.Latitude
	lon1=p1.Longitude
	lat2=p2.Latitude
	lon2=p2.Longitude
	Try
		lat1 = lat1 * cPI / 180
		lon1 = -lon1 * cPI / 180
		lat2 = lat2 * cPI / 180
		lon2 = -lon2 * cPI / 180
		D = 2 * ASin(Sqrt(Power(Sin((lat1-lat2)/2),2) + Cos(lat1)*Cos(lat2)*Power(Sin((lon1-lon2)/2),2)))
		Dist = D * 180 * 60 * 1852/cPI
		Return Abs(Dist)
	Catch
		Return 0
	End Try
End Sub

'geo-point located at a distance along the azimuth degree
Sub Next_Point(FirstPoint As Location, Dist As Float, Az As Float) As Location
	Dim Radius As Double = 6372795.477598
	Dim res As Location
	Dim LatA As Float = FirstPoint.Latitude
	Dim LonA As Float = FirstPoint.Longitude
	Dim LatB As Float = ASinD(SinD(LatA) * Cos(Dist/Radius) + CosD(LatA) * Sin(Dist/Radius) * CosD(Az))
	Dim LonB As Float = LonA + ATan2D(SinD(Az) * Sin(Dist / Radius) * CosD(LatA), Cos(Dist / Radius) - SinD(LatA) * SinD(LatB))
	res.Initialize2(LatB, LonB)
	Return res
End Sub

Sub SortMapKeys (m As Map, SortAsc As Boolean)
	Try
		If m.IsInitialized = False Or m.Size = 0 Then Return

		Private KeysList As List:KeysList.Initialize
		Private m2 As Map:m2.Initialize
		
		For i = 0 To m.Size - 1
			Private key As String = m.GetKeyAt(i)
			KeysList.Add(key)
		Next
		
		KeysList.SortCaseInsensitive(SortAsc)

		For x=0 To KeysList.Size - 1
			Private key As String = KeysList.Get(x)
			Private val As Object = m.Get(key)
			m2.Put(key, val)
		Next
		m.Clear
		For Each m2Key As String In m2.Keys
			m.Put(m2Key, m2.Get(m2Key))
		Next
		'Log("m sorted:" & m)
	Catch
	End Try
End Sub

Sub Kill_Call
	Dim r As Reflector
	r.Target = r.GetContext
	Dim TelephonyManager, TelephonyInterface As Object
	TelephonyManager = r.RunMethod2("getSystemService", "phone", "java.lang.String")
	r.Target = TelephonyManager
	TelephonyInterface = r.RunMethod("getITelephony")
	r.Target = TelephonyInterface
	r.RunMethod("endCall")
End Sub